{ fp }
{$B-,R-,O+,H+}
const InFile = 'evo.dat';
   OutFile   = 'evo.sol';
   base      = 10;
   baseLen   = 1;
   numL      = 35;

type LongNum = record
                  d : array[1..(numL+baseLen-1) div baseLen] of smallint;
                  n : integer;
               end;

function string2LongNum(const s : string) : LongNum;
var res   : LongNum;
   i,j,sn : integer;
   rem    : longint;
begin
   res.n:=0;
   sn:=length(s);
   i:=sn;
   while i>0 do begin
      rem:=0;
      for j:=i-baseLen+1 to i do
         if j>0 then rem:=10*rem+ord(s[j])-ord('0');
      inc(res.n);
      res.d[res.n]:=rem;
      dec(i,baseLen);
   end;
   string2LongNum:=res;
end;

procedure WriteLongNum(const ln : LongNum);
var
   i,zc : integer;
   x    : longint;
begin
   if ln.n=0 then write('0')
   else begin
      write(ln.d[ln.n]);
      for i:=ln.n-1 downto 1 do begin
         x:=ln.d[i];
         zc:=0;
         while x<>0 do begin inc(zc);x:=x div 10; end;
         while zc<baseLen do begin inc(zc);write('0');end;
         if ln.d[i]<>0 then write(ln.d[i]);
      end;
   end;
end;

function numcmp(const a,b : LongNum) : integer;
var i,asz,bsz : integer;
begin
   if a.n>b.n then numcmp:=1
   else if a.n<b.n then numcmp:=-1
   else begin
      i:=a.n;
      while (i>0) and (a.d[i]=b.d[i]) do dec(i);
      if i<=0 then numcmp:=0
      else if a.d[i]>b.d[i] then numcmp:=1
      else numcmp:=-1;
   end;
end;

function numdiv(const a : LongNum; d : integer) : LongNum;
var
   res       : LongNum;
   i,rem,asz : integer;
begin
   res.n:=a.n;
   rem:=0;
   for i:=a.n downto 1 do begin
      rem:=base*rem+a.d[i];
      res.d[i]:=rem div d;
      rem:=rem mod d;
   end;
   while (res.n>0) and (res.d[res.n]=0) do dec(res.n);
   numdiv:=res;
end;
var n,c  : integer;
   as,bs : string;
   a,b   : LongNum;
begin

   assign(input,InFile);reset(input);
   assign(output,Outfile);rewrite(output);

   readln(n);readln(as);readln(bs);
   a:=string2LongNum(as);
   b:=string2LongNum(bs);
   repeat
      c:=numcmp(a,b);
      if c>0 then a:=numdiv(a,2);
      if c<0 then b:=numdiv(b,2);
   until c=0;
   WriteLongNum(a);writeln;
   close(input);close(output);
end.
