#include <cstdio>
#include <fstream>
#include <cstdlib>

using namespace std;

const char *infile="ridge.dat";
const char *outfile="ridge.sol";

const int maxN=100000;

typedef long long LLong;

int h[maxN];
int view[maxN];
char buf[maxN*8+128];

int main() {
     int n,t,i;
     int beg,end;
     char *p;
     LLong res,cur;
     FILE *ifs=fopen(infile,"r");
     ofstream ofs(outfile);

     fscanf(ifs,"%d%d\n",&n,&t);
     fgets(buf,sizeof(buf),ifs);
     for(i=0,p=buf;i<n;i++)
          h[i]=strtol(p,&p,10);
     
     for(i=0;i<n;i++) {
          for(beg=i;beg-1>=0 &&h[beg-1]<h[i];beg--);
          for(end=i;end+1<n&&h[end+1]<h[i];end++);          
          view[i]=end-beg;
     }

     for(i=0,res=-1,cur=0;i<n;i++) {
          cur+=view[i];
          if(i>=t)cur-=view[i-t];
          if(res<cur)res=cur;
     }

     ofs<<res<<endl;

     fclose(ifs);
     return 0;
}
