#include <cstdio>
#include <iostream>
#include <fstream>
#include <algorithm>

using namespace std;

const char *infile="ridge.dat";
const char *outfile="ridge.sol";

const int maxN=100000;
const int logN=17;

typedef long long LLong;

int h[maxN];
int beg[logN][maxN];
int end[logN][maxN];

int main() {
     int n,t,i,k;
     LLong res,cur;
     FILE *ifs=fopen(infile,"r");
     ofstream ofs(outfile);

     fscanf(ifs,"%d%d",&n,&t);
     for(i=0;i<n;i++)fscanf(ifs,"%d",&h[i]);
     
     for(i=0;i<n;i++) {
          beg[0][i]=i-1;
          for(k=0;1<<(k+1)<=i;k++);
          for(;k>=0;k--) {
               while(beg[0][i]>=0&&beg[k][beg[0][i]]>=0&&h[beg[k][beg[0][i]]]<h[i])beg[0][i]=beg[k][beg[0][i]];
               k--;
          }
          for(;beg[0][i]>=0&&h[beg[0][i]]<h[i];beg[0][i]=beg[0][beg[0][i]]);
          for(k=0;k<logN-1;k++)
               if(beg[k][i]>=0)beg[k+1][i]=beg[k][beg[k][i]];
               else beg[k+1][i]=-1;
     }
     for(i=n-1;i>=0;i--) {
          end[0][i]=i+1;
          for(k=0;1<<(k+1)<=n-i-1;k++);
          for(;k>=0;k--) {
               while(end[0][i]<n&&end[k][end[0][i]]<n&&h[end[k][end[0][i]]]<h[i])end[0][i]=end[k][end[0][i]];
               k--;
          }
          for(;end[0][i]<n&&h[end[0][i]]<h[i];end[0][i]=end[0][end[0][i]]);
          for(k=0;k<logN-1;k++)
               if(end[k][i]<n)end[k+1][i]=end[k][end[k][i]];
               else end[k+1][i]=n;
     }

     for(i=0,res=-1,cur=0;i<n;i++) {
          cur+=end[0][i]-beg[0][i]-2;
          if(i>=t)cur-=end[0][i-t]-beg[0][i-t]-2;
          if(res<cur)res=cur;
     }

     ofs<<res<<endl;

     fclose(ifs);
     return 0;
}
