/* vc_cpp */
/*

 '  TANGLE.

O(n^2)

*/
#include <vector>
#include <queue>
#include <iostream>
#include <fstream>


using namespace std;

#define MAX (1<<20)

ifstream ifs("tangle.dat");
ofstream ofs("tangle.sol");
int d, n;
int f[MAX];
long long ans;

long long calc(int l, int r)
{
    if (l+2 == r)
        return  0;
    long long sec1, sec2;
    int m;
    sec1 = sec2 = 0;
    m = (l+r)/2;

    for (int i = l; i < m; ++i)
        for (int j = m; j < r; ++j)
            if (f[i] > f[j])
                sec1 ++;

    for (int i = l; i < m; ++i)
        for (int j = m; j < r; ++j)
            if (f[i] < f[j])
                sec2 ++;
    //cout << l << " " << r << " : " << sec1 << " " << sec2<< endl;
    return min(sec1, sec2) + calc(l, m) + calc(m, r);
}

int main ()
{
    int i, a, b;

    ifs >> d;
    n = 1<<d;
	for (i = 0; i < n; ++i)
	{
        ifs >> a;
        f[i] = a-1;
	}

    ofs << calc(0, n) << endl;

	return 0;
}