#include <cstdio>
#include <fstream>

using namespace std;

const char *infile="ridge.dat";
const char *outfile="ridge.sol";

const int maxN=100000;

typedef long long LLong;

int h[maxN];
int prv[maxN];
int nxt[maxN];
int stk[maxN];

int main() {
     int n,t,i,stksz;
     LLong res,cur;
     FILE *ifs=fopen(infile,"r");
     ofstream ofs(outfile);

     fscanf(ifs,"%d%d",&n,&t);
     for(i=0;i<n;i++)fscanf(ifs,"%d",&h[i]);
     
     for(i=0,stksz=0;i<n;i++) {
          while(stksz&&h[stk[stksz-1]]<h[i])stksz--,nxt[stk[stksz]]=i;
          if(stksz)prv[i]=stk[stksz-1];
          else prv[i]=-1;
          if(stksz&&h[stk[stksz-1]]==h[i])stksz--,nxt[stk[stksz]]=i;
          stk[stksz++]=i;
     }
     while(stksz)stksz--,nxt[stk[stksz]]=n;
     
     for(i=0,res=-1,cur=0;i<n;i++) {
          cur+=nxt[i]-prv[i]-2;
          if(i>=t)cur-=nxt[i-t]-prv[i-t]-2;
          if(res<cur)res=cur;
     }
     
     ofs<<res<<endl;

     fclose(ifs);
     return 0;
}
